/*
 * libshcodecs: A library for controlling SH-Mobile hardware codecs
 * Copyright (C) 2009 Renesas Technology Corp.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA  02110-1301 USA
 */

#ifndef	AVCBE_INNER_H
#define	AVCBE_INNER_H

#include <setjmp.h>

#include "m4iph_vpu4.h"

#ifdef __cplusplus
extern "C" {
#endif

#define AVCBE_INTRA_OFFSET_NUM		52	/* ȥ饪եåȤθĿ */

/* avcbe_output_byteؿνϥ(H.264 only) */
#define AVCBE_PUT_HEADER	0	/* 060125 */
#define AVCBE_PUT_END_CODE	1
#define AVCBE_PUT_OTHERS	2

/* avcbe_add_trailing_bitsؿνϥ(H.264 only) */
#define AVCBE_NOT_TRB	0	/* 060127 */
#define AVCBE_ADD_TRB	1	/* 060127 */

/*----- avcbe_rate_control_info_t¤ -----*/
	typedef struct {/*--- VPU4ǥ󥳡Υ졼ȥȥξ ---*/
		char quant_init_i;	/* I-VOPQ */
		char quant_init_p;	/* P-VOPQ */
		char quant_init_b;	/* B-VOPQ */
		char use_dquant;	/* DQUANTλѥե饰 */
		char clip_dquant;	/* DQUANTΤȤ˥åפϰ(MPEG-4ΤȤϻѤʤ) */
		char gvop_m;	/* GVOP M(1:Low Delay(B-VOPʤ), 0:Low DelayǤʤ(B-VOP))VPU4ǥ󥳡H.264ȥ꡼ǤϾ=1 */
		char coef_cut_enable;	/* ̤ˤ,QΥꥢ(H.264ξϾ0¤ʤ) */
		char quality_mode;	/* ̻Ҳ¹ԥ⡼ɡH.264ξϾ0ʻѤʤ) */

		char quant_min;	/* QμꤦǾ */
		char quant_max;	/* Qμꤦ */
		char vop_min_stuffing;	/* VOPκ̤ˤʤ褦åե󥰤ͤ뤫0:ͤʤ1:ͤ롢H.264ξϾ0ʻѤʤ) */
		char coef_enc_area;	/* MB̻Ҳ¹ԥꥢ(H.264ξϾ0ʻѤʤ) */
		char first_p_pic_out;	/* PԥϤ0: ޤPԥϤƤʤ1: PԥϺѤߡ */
		char ratecontrol_skip_enable;	/* ե졼ॹåפԤݤ */
		char dummy_3;	/* 4Хȶˤ뤿Υߡ */

		long cur_quant;	/* Υե졼Q͡ʼꤦͤcharǤबΨlongˤ */
		float cur_f_quant;	/* Υե졼Q͡ʼꤦͤcharǤबΨlongˤ *//* 041213 */
		long prev_quant;	/* ľΥե졼Q */

		long Ni;	/* Nbr I-VOP remaining in GOV */
		long Np;	/* Nbr P-VOP remaining in GOV */
		long Nb;	/* Nbr B-VOP remaining in GOV */

		long d0i;	/* I-VOP virtual vuffer occupancy */
		long d0p;	/* P-VOP virtual vuffer occupancy */
		long d0b;	/* B-VOP virtual vuffer occupancy */

		unsigned long cpb_buf_size;	/* cpb Хåե *//* Rename vbv -> cpb 040729 Y.Funabashi */
		long cpb_buf_remain;	/* cpb Хåե *//* Rename vbv -> cpb 040729 Y.Funabashi  */

		long vbv_buf_size;
		long vbv_buf_remain;

		long T_tm5;	/* mb_target_bitsȤꤹ */
		long T_min;	/* vop_min_bitsȤꤹ(H.264ξϾ0ʻѤʤ) */
		long T_max;	/* mb_max_bitsȤꤹ */
		long r_tm5;	/* reaction_paramȤꤹ */
		long d_tm5;	/* virtual_buf_sizeȤꤹ */

		long R_tm5;	/* remaining bits for GOV */

		float Xi;	/* I-VOP complexity *//* ϡɥब󥳡longʤΤǡfloatȤɤ餬褤Ƥ뤳 */
		float Xp;	/* P-VOP complexity */
		float Xb;	/* B-VOP complexity */

		unsigned long avcbe_target_Ipic_frame_bits;	/* ɸIԥƥӥå 040726 Add Y.Funabashi  */
		unsigned long avcbe_target_Ppic_frame_bits;	/* ɸPԥƥӥå 040726 Add Y.Funabashi  */
		unsigned long avcbe_cumurative_bits_rc_unit;	/* ӤΥԥƥӥå(RC) 040726 Add Y.Funabashi  */
		unsigned long avcbe_cumurative_target_bits_rc_unit;	/* ɸΥԥƥӥå(RC) 040726 Add Y.Funabashi  */
		unsigned long avcbe_rate_ctrl_type;	/* Qͥȥ륢르ꥺTM5ˤ뤫ForDSCˤ뤫ե饰 041208 Add Y.Funabashi  *//* 041213 */
		unsigned long avcbe_cpb_start_size;	/* Qͥȥ륢르ꥺTM5ˤ뤫ForDSCˤ뤫ե饰 041208 Add Y.Funabashi  *//* 041213 */

#ifdef SH
		unsigned long long avcbe_cumurative_bits;	/* ӤΥԥƥӥå 040726 Add Y.Funabashi  */
		unsigned long long avcbe_cumurative_target_bits;	/* ɸΥԥƥӥå 040726 Add Y.Funabashi  */
#else
		unsigned _int64 avcbe_cumurative_bits;	/* ӤΥԥƥӥå 040726 Add Y.Funabashi  *//* VC++Ǥϡ64bit Integer_int64 041020 */
		unsigned _int64 avcbe_cumurative_target_bits;	/* ɸΥԥƥӥå 040726 Add Y.Funabashi  *//* 041020 */
#endif

		unsigned long avcbe_activity_sum_pic;	/* ƥӥƥι͡1ե졼ʬ *//* 050422 */
		unsigned long avcbe_activity_sum_slice;	/* ƥӥƥι͡1饤ʬ *//* 050422 */
		unsigned long avcbe_activity_sum_mb;	/* ƥӥƥι͡1ե졼ʬˤޥ֥åǳä1/2 *//* 050422 */

	} avcbe_rate_control_info_t;

/*----- avcbe nal unit info¤ -----*/
	typedef struct {
/*	long	avcbe_forbidden_zero_bit; */
		long avcbe_nal_ref_idc;
		long avcbe_nal_unit_type;
	} AVCBE_NAL_UNIT_INFO;

/*----- avcbe sequence parameter set info¤ -----*/
	typedef struct {
		long avcbe_profile_idc;
		long avcbe_constraint_set0_flag;	/* 041102 */
		long avcbe_constraint_set1_flag;	/* 041102 */
		long avcbe_constraint_set2_flag;	/* 041102 */
		long avcbe_level_idc;
		long avcbe_seq_param_set_ID;
		long avcbe_log2_max_frame_num_minus4;
		long avcbe_pic_order_cnt_type;
		long avcbe_log2_max_pic_order_cnt_lsb_minus4;
		long avcbe_delta_pic_order_always_zero_flag;
		long avcbe_offset_for_non_ref_pic;
		long avcbe_offset_for_top_to_bottom_field;
		long avcbe_num_ref_frames_in_pic_order_cnt_cycle;
		long avcbe_offset_for_ref_frame[256];
		long avcbe_num_ref_frames;
		long avcbe_gaps_in_frame_num_value_allowed_flag;
		long avcbe_pic_width_in_mbs_minus1;
		long avcbe_pic_height_in_map_units_minus1;
		long avcbe_frame_mbs_only_flag;
		long avcbe_mb_adaptive_frame_field_flag;
		long avcbe_direct_8x8_inference_flag;
		long avcbe_frame_cropping_flag;
		long avcbe_frame_crop_left_offset;
		long avcbe_frame_crop_right_offset;
		long avcbe_frame_crop_top_offset;
		long avcbe_frame_crop_bottom_offset;
		long avcbe_vui_parameters_present_flag;
		long avcbe_SPS_header_bits;	/* SPSΥӥåȿ(RateControlǻ) */
	} AVCBE_SPS_INFO;

/*----- avcbe picture parameter set info¤ -----*/
	typedef struct {
		long avcbe_pic_parameter_set_ID;
		long avcbe_seq_param_set_ID;
		long avcbe_entropy_coding_mode_flag;
		long avcbe_pic_order_present_flag;
		long avcbe_num_slice_groups_minus1;
		long avcbe_num_ref_idx_l0_active_minus1;
		long avcbe_num_ref_idx_l1_active_minus1;
		long avcbe_weighted_pred_flag;
		long avcbe_weighted_bipred_idc;
		long avcbe_pic_init_qp_minus26;
		long avcbe_pic_init_qs_minus26;
		long avcbe_chroma_qp_index_offset;
		long avcbe_deblocking_filter_control_present_flag;	/* 041106 ̾ѹ */
		long avcbe_constrained_intra_pred_flag;
		long avcbe_redundant_pic_cnt_present_flag;
		long avcbe_PPS_header_bits;	/* PPSΥӥåȿ(RateControlǻ) */
	} AVCBE_PPS_INFO;

	/*----- avcbe_slice_info¤ -----*//* Ȥֹѹʤ!! */
	typedef struct {
		long avcbe_first_mb_in_slice;	/* (1) *//* M4IPH_VPU4_ENC¤ΤΥФˤͤϤ(m4iph_avc_first_mb_in_slice) */
		long avcbe_slice_type;	/* (2) */
		long avcbe_pic_parameter_set_id;	/* (3) */
		long avcbe_frame_num;	/* (4) */
		long avcbe_prev_frame_num;	/* (5) *//* SEIǻȤ뤿˥Хååפ *//* 041214 */

		long avcbe_idr_pic_id;	/* (5) */
		long avcbe_pic_order_cnt_lsb;	/* (6) */
		long avcbe_delta_pic_order_cnt[2];	/* (7) */

		long avcbe_num_ref_idx_active_override_flag;	/* (8) */
		long avcbe_slice_qp_delta;	/* (9) */
		long avcbe_disable_deblocking_filter_idc;	/* (10) */
		long avcbe_slice_alpha_c0_offset_div2;	/* (11) *//* M4IPH_VPU4_ENC¤ΤΥФˤͤϤ(m4iph_avc_alpha_offset) */
		long avcbe_slice_beta_offset_div2;	/* (12) *//* M4IPH_VPU4_ENC¤ΤΥФˤͤϤ(m4iph_avc_beta_offset) */
		long avcbe_ref_pic_list_reordering_flag_l0;	/* (13) */
		long avcbe_reordering_of_pic_nums_idc;	/* (14) *//* 041106 */
		long avcbe_abs_diff_pic_num_minus1;	/* (15) *//* 041106 */
		long avcbe_no_output_od_prior_pics_flag;	/* (16) */
		long avcbe_long_term_reference_flag;	/* (17) */
		long avcbe_adaptive_ref_pic_making_mode_flag;	/* (18) */

		long avcbe_vop_type;	/* (19) *//* 1avcbe_encode_picture()Ǥȯӥå */
		long avcbe_deblock_disable;	/* (20) *//* M4IPH_VPU4_ENC¤ΤΥФˤͤϤ(m4iph_avc_deblock_disable) */
		long avcbe_vop_quant;	/* (21) *//* M4IPH_VPU4_ENC¤ΤΥФˤͤϤ(m4iph_vop_quant) */
		long avcbe_slice_next_quant;	/* (22) *//* 041118 */

		long avcbe_use_multi_reference;	/* (23) */
		long *avcbe_stream_out;	/* (24) *//* ȥ꡼Хåե(饤إåϻ˻) */
		long avcbe_slice_header_total_bits;	/* (25) *//* 饤إåΥȡӥåȿ */
		long avcbe_slice_total_bits_for_frame;	/* (26) *//* NALñ̥󥳡ɤǤȯӥå(1ե졼ʬ) *//* 041118 */
		long avcbe_outputed_continue_bits;	/* (27) *//* continueؿǽϤӥåȿ *//* 050707 */
		long avcbe_last_slice_data_continue_bits;	/* (28) *//* continue⡼ɻ饤νΥǡΥӥåȿ *//* 050707 */
		long avcbe_used_continue_in_slice;	/* (29) *//* continue⡼ɻ1饤ǥƥ˥塼ɤ(1Ǥ⥳ƥ˥塼ϡ֣פˤ) *//* 050708 */

	} AVCBE_SLICE_INFO;

	/* avcbe.hưʳ˸ʤ *//* 050218 */

/* APIؿavcbe_set_weightedQ()Ϥι¤(3)avcbe_weightedQ_mode = AVCBE_WEIGHTEDQ_BY_USERΤȤ˻Ѥ */
	typedef struct {
		long avcbe_weight_type;	/* (1) */
		long avcbe_mode_for_bit1;	/* (2) */
		long avcbe_mode_for_bit2;	/* (3) */
		long avcbe_mode_for_bit3;	/* (4) */
		long avcbe_Qweight_for_bit1;	/* (5) */
		long avcbe_Qweight_for_bit2;	/* (6) */
		long avcbe_Qweight_for_bit3;	/* (7) */
		char *avcbe_MB_table;	/* (8) */
		unsigned long avcbe_num_of_MB_table;	/* (9) */
	} TAVCBE_WEIGHTEDQ_USER;

#if 0				/* 050526 */
/* APIؿavcbe_set_VUI_parameters()Ϥưѥѥ᡼Τߡ(H.264 only) */
	typedef struct {
		long avcbe_bit_rate_scale;	/* (1)        *//* Ǽưꤹͤѹ *//* 050524 */
		long avcbe_cpb_size_scale;	/* (2)        *//* Ǽưꤹͤѹ *//* 050524 */
	} avcbe_inner_vui_hrd_param;
#endif

/* APIؿavcbe_set_SEI_parameters()Ϥι¤(6)DEC_REF_PIC_MARKING_REPETITION (H.264 only) */
	typedef struct {
		unsigned long avcbe_original_idr_flag;	/* (1) */
		unsigned long avcbe_original_frame_num;	/* (2) */
		unsigned long avcbe_original_field_pic_flag;	/* (3) */
		unsigned long avcbe_original_bottom_field_flag;	/* (4) */

		unsigned long avcbe_use_output_of_prior_pics_long_term_reference;	/* (5) */
		unsigned long avcbe_no_output_of_prior_pics_flag;	/* (6) */
		unsigned long avcbe_adaptive_ref_pic_making_mode_flag;	/* (7) *//* 041122 */
		unsigned long avcbe_long_term_reference_flag;	/* (8) */
	} avcbe_sei_dec_ref_pic_marking_repetition_param;

/* Work area information */
	typedef struct {
		jmp_buf jmpbuf;	/* for setjmp, longjmp */
		jmp_buf jmpbuf2;	/* for setjmp, longjmp *//* ֤=-4ǻ *//* 050523 */
		unsigned char *work_area_top;	/* ץꥱ󤫤Ϥ줿ꥢƬɥ쥹 */
		unsigned long alloc_work_area_size;	/* ꥢλѲǽʥХȿ */
		unsigned long used_work_area_size;	/* 嵭ΤɤޤǻѤΥХȿ */
		unsigned long used_work_area_size_previous;	/* ˥ȤȤ˻ѤƤХȿ */
	} AVCBE_WORK_AREA_INFO_t;

	/* avcbe.hưޤǡʳ˸ʤ *//* 050218 */


/*----- avcbe_H264_stream_info_t¤ -----*/

	typedef struct AVCBE_H264_STREAM_INFO {
					/*--- 󥳡H.264ȥ꡼ऴȤξ ---*/

		/*      unsigned long avcbe_stream_ID; *//* Υȥ꡼μֹ0, 1, 2, , ȥ꡼1 */
		unsigned long avcbe_stream_type;	/* Υȥ꡼ΥסAVCBE_MPEG4, AVCBE_H263, AVCBE_H264 */

		/* ȥ꡼ऴȤΥ󥰥󥹥å */
		long avcbe_stream_check_flg;

		AVCBE_WORK_AREA_INFO_t avcbe_work_area_info_for_stream;	/* Υȥ꡼Υΰξ */

		unsigned char *avcbe_stream_buff;	/* avcbe_encode_picture()Ϥ줿ȥ꡼ϥХåեƬɥ쥹 */
		unsigned long avcbe_stream_buff_size;	/* Ʊȥ꡼ϥХåեΥñ̡Хȡ */
		unsigned long avcbe_used_stream_buff_size_bits;	/* ȥ꡼ϥХåեλ(եȤǽϤʬΤ)ʥХȡ */
		long avcbe_stream_output_flag;	/* =0-1Хåե­ */

/*--- ޤǤϡMPEG-4Ѥι¤m4vse_MPEG4_stream_info_tƱˤƤΤǤʤ ---*/

		long avcbe_output_type;	/* avcbe_encode_pictureؿΰoutput_type *//* 050105 */
		/* AU delimiter *//* 041115 */
		unsigned char *avcbe_AUD_stream_buff;	/* avcbe_encode_picture()Ϥ줿AUDѥȥ꡼ϥХåեƬɥ쥹 */
		unsigned long avcbe_AUD_stream_buff_size;	/* Ʊȥ꡼ϥХåեΥñ̡Хȡ */

		/* SEI *//* 041210 */
		unsigned char *avcbe_SEI_stream_buff;	/* SEIѥȥ꡼ϥХåեƬɥ쥹 */
		unsigned long avcbe_SEI_stream_buff_size;	/* Ʊȥ꡼ϥХåեΥñ̡Хȡ */

	/*--- ޤǤϡMPEG-4,H.263Ѥι¤m4vse_MPEG4_stream_info_tƱˤƤ ---*/
		/* ¾Υȥ꡼ऴȤΥХѿ */
		char avcbe_EndEncoding;
		char avcbe_start_flag;	/* avcbe_encode_picture()뤵줿Ȥ0:ܰʹߤΥե졼ࡢ1:ƬΥե졼ࡢ2:ܰʹߤΥե졼Ǻƽ */
		char avcbe_prev_start_flag;	/* avcbe_start_flagΥХåå *//* 041224 */
		char avcbe_vpu_continue_flag;	/* =1:continue=0:continueƤʤ *//* 050203 */

		/* APIؿavcbe_init_encode()ǻꤵ줿󥳡ɥѥ᡼ */
		avcbe_encoding_property avcbe_encode_option;
		avcbe_other_options_h264 avcbe_encode_other_opt_h264;

		/* ΰξʥǥɲν衢ȥե졼 */
		unsigned char avcbe_ldec_index;	/* ǥɲν(ΰΥǥåֹ:0 to N-1) ե졼2ʾ */
		unsigned char avcbe_ref1_index;	/* ȥե졼(ΰΥǥåֹ:0 to N-1) */
		unsigned char avcbe_ref2_index;	/* ޥե󥹤ΤȤŪref1βΰλȲֹ:0 to N-1) */


		long avcbe_num_of_mb;	/* ȹ⤵ޤޥ֥å(((+15)/16)x16)x(((⤵+15)/16)x16) */
		long avcbe_num_of_mb_4x;	/* 4ܿˤޥ֥å *//* 041027 */

		long avcbe_vop_bits;	/* ե졼ñ̤Υӥåȯ */
		long avcbe_out_stream_bits;	/* ӥåȯ̤߷ */

		TAVCBE_FMEM avcbe_captbuf[1];	/* ץΰ */

		unsigned char avcbe_nrefframe;	/* ȥե졼(VPU4ǥ󥳡Ǥ1 or 2) */

		unsigned char avcbe_nldecfmem;	/* ΰΥե졼 */
		TAVCBE_FMEM *avcbe_ldecbuf;	/* ΰΥɥ쥹ơ֥ʥե졼2ʾǾ¤ʤȤ롣255ޤǡ */

		unsigned char avcbe_npfiltfmem;	/* ݥȥե륿ΰΥե졼 */
		TAVCBE_FMEM avcbe_pfiltfbuf[1];	/* ݥȥե륿ΰ */

		/* 0x03ѤtempХåե *//* 041128 */
		/* avcbe_output_byte()ǽϤƤ4byteñ̤ƤΤǡñ̤٤0x000000ɤϤ
		   礬äΤǰtempХåե˥إå򤹤٤ίƤ0x03ߤˤ */
		char avcbe_temp_stream_buff_1[500];	/* 256->300->500byte *//* 060213 *//* 060307 */
		char avcbe_temp_stream_buff_2[500];	/* 256->300->500byte *//* 060213 *//* 060307 */

		long avcbe_h264_profile;
		long avcbe_h264_level;

		long avcbe_set_intra;

		/*      long avcbe_quant_mod_ratio; *//* 100% *//* ѤʤΤǺ 050518 */

		long avcbe_frm_interval;	/* ¤avcbe_frame_statΥФΤɬפʤ 040909 */
		avcbe_slice_stat avcbe_last_slice_stat;

		/* إå *//* 060127 */
		avcbe_SPS_header_info_stat avcbe_last_SPS_header_info;
		avcbe_PPS_header_info_stat avcbe_last_PPS_header_info;
		avcbe_slice_header_info_stat avcbe_last_slice_header_info;

		/* ӥåȥ졼ȴƻ */
		long avcbe_bitrate_watch_index;	/* Ǹ˽ڤΥǥåֹ */
		long avcbe_bitrate_remainder_size;	/* ڤꤴȤΥӥåȥλĤ */


		/* ȥ꡼ϥХåե­ȯȤ˸ƤӽФ٤桼ؿ */
		 avcbe_buf_continue_userproc_ptr
		    avcbe_buf_continue_userproc;
		long avcbe_slice_header_output_bits;	/* ȥ꡼ϥХåե˥եȤǽϤʥӥåñ̡˥ȥ꡼ϥХåե­ΤȤ˻Ѥ *//* 050628 */

		/* VPU4ɥ饤˥󥳡ɥѥ᡼Ϥ */
		M4IPH_VPU4_ENC avcbe_vpu4_enc_info;

		/* VPU4ɥ饤饨󥳡ɷ̤뤿 */
		M4IPH_VPU4_ENC_RES avcbe_vpu4_enc_res;

		/* NAL Unit SyntaxѤι¤ */
		AVCBE_NAL_UNIT_INFO avcbe_nal_info;

		/* Sequence Parameter SetѤι¤ */
		AVCBE_SPS_INFO avcbe_SPS_info;

		/* Picture Parameter SetѤι¤ */
		AVCBE_PPS_INFO avcbe_PPS_info;

		/* 饤إåѤι¤ */
		AVCBE_SLICE_INFO avcbe_slice_header_info;

		/* VUIѥ᡼Ѥι¤ */
		avcbe_vui_main_param *avcbe_vui_info;	/* 󥳡ɥѥ᡼avcbe_use_vui_parametersONʤСΰ˳Ƥ */
		long avcbe_non_vcl_bits;	/* nal_hrd_present_flag=ONξΥإåʬ(Ratecontrolcpb_buf_remain) *//* 050526 */


#if 0				/* 050526 */
		avcbe_inner_vui_hrd_param inner_vui_hrd_param;	/* 050524 */
#endif

		long *avcbe_mb_table;	/* B-VOPΤȤ˥ΥåȥǥåȾݻ뤿Υơ֥롢ǿϥޥ֥å */


		/* ȥ꡼ॿפH.264ΤȤѤΤ */
		long avcbe_encoded_mb_num;	/* 饤ʬ䤹ȤĤΥޥ֥å줿 */

		long avcbe_insert_emulation_prevention_flag;	/* 0x03ɡemulation_preventionˤ뤫ݤʥǥեȤ *//* 060124 */
		unsigned char avcbe_primary_pic_type;	/* AU Delimiterprimary_pic_typeνϻ *//* 060124 */
		unsigned char avcbe_use_I_PCM;	/* I-PCMѡavcbe_set_use_I_PCMؿǥåȤ *//* 060124 */
		unsigned char avcbe_slice_next_Q;	/* nextQON/OFF(饤ʬ˻) *//* 060124 */
		long avcbe_use_intra_offset;	/* ȥ饪եå *//* =1:ȥ饪եåȤ򱣤APIؿavcbe_set_intra_offsetꤹ롣=0:ȥ饪եåȤꤷʤʥǥեȡ *//* 060124 */


		char avcbe_use_multi_ref;	/* ޥե󥹤ݤζ */
		/* 050408       char avcbe_put_three_byte;      *//* prevention_emulation_three_byte뤫ʥǥեͤAVCBE_ON= */

		/* 졼ȥȥϢ */
		char avcbe_pic_type;	/* Υե졼ΥԥμAVCBE_IDR_PIC/AVCBE_I_PIC/AVCBE_P_PIC */
		char avcbe_prev_pic_type;	/* ľ˥󥳡ɤե졼Υԥμʥե졼ॹåפե졼Ͻ */
		char avcbe_I_vop_skip_value;	/* I-VOP򥹥åפ1򥻥å *//* Хѿäȥ꡼ऴȤ˻ *//* 050425 */
		char avcbe_prev_I_pic_flag;	/* ȥ꡼ऴȤ˻褦ѹ 050425 */
		char avcbe_prev_I_quant_value;	/* ȥ꡼ऴȤ˻褦ѹ 050425 */
		char avcbe_ncram_weightq_flag;	/* ȥ꡼ऴȤ˻褦ѹ 050425 */
		char avcbe_wq_read_flag;	/* avcbe_g_nc_ram_endե饰 050518 */
		char avcbe_wq_write_flag;	/* avcbe_g_median_filter_endե饰 050518 */

		long avcbe_x_mb_size;	/* Υޥ֥å *//* 050518 */
		long avcbe_y_mb_size;	/* Υޥ֥å *//* 050518 */

		long avcbe_I_pic_count;	/* Ū뤿ΡIԥIDRԥޤˤΥ */
		long avcbe_frm_rate_count;	/* 1ü˥ӥåȥ졼椹뤿Υե졼󥿡P-Pic⡼ɤѡ */
		float avcbe_skip_counter;	/* Ϣ³åץ */
		float avcbe_skip_limit;	/* Ϣ³å׺ */

		long avcbe_I_quant_offset_minus_range_flag;	/* ȥ꡼ऴȤ˻ 050425 */
		long avcbe_prev_remain_buff;	/* ȥ꡼ऴȤ˻ 050425 */
		float avcbe_f_cpb_offset;	/* 󥳡ɥѥ᡼avcbe_ratecontrol_cpb_offset(long)ͤ1/10ͤ 050520 */
		float avcbe_f_cpb_offset_rate;	/* cpb buffer Фcpb_lowerϰϤcpb_minϰϤΨ *//* 󥳡ɥѥ᡼avcbe_ratecontrol_cpb_offset_rate(long)ͤ1/10ͤ 050520 */
		/*      float avcbe_cpb_stack_rate; *//* cpb buffer ˳ϻƤ *//* avcbe_g_cpb_offsetͤϥ󥳡ɥѥ᡼ǻꤹ褦ѹΤ 050520 */

		long avcbe_remain_sum;	/* ȥ꡼ऴȤ˻ 050427 */
		long avcbe_cpb_buff_per_frm_over_cnt;	/* ȥ꡼ऴȤ˻ 050427 */

		long avcbe_1_thr;	/* ȥ꡼ऴȤ˻ 050425 */
		long avcbe_2_thr;	/* ȥ꡼ऴȤ˻ 050425 */
		long avcbe_3_thr;	/* ȥ꡼ऴȤ˻ 050425 */
		long avcbe_4_thr;	/* ȥ꡼ऴȤ˻ 050425 */
		long avcbe_5_thr;	/* ȥ꡼ऴȤ˻ 050425 */

		long avcbe_quant_max_thr1;	/* ȥ꡼ऴȤ˻ 050425 */
		long avcbe_quant_max_thr2;	/* ȥ꡼ऴȤ˻ 050425 */
		long avcbe_quant_max_thr3;	/* ȥ꡼ऴȤ˻ 050425 */
		long avcbe_quant_max_thr4;	/* ȥ꡼ऴȤ˻ 050425 */

		avcbe_rate_control_info_t avcbe_rate_con;	/* åȥӥå̤Qͤ򻻽Ф뤿ξ */

		/* ŪINTRAޥ֥åեåϢ */
		long avcbe_intraRefreshMBnum;	/* ե졼ऴȤ˥եå夹ޥ֥å */
		long avcbe_cyclicIntraCounter;	/* Ū˥եå夹뤿Υ */

		long avcbe_frm;	/* 󥨥󥳡ɤե졼Υե졼ֹʻ֡ */
		long avcbe_prev_frm;	/* ľ˥󥳡ɤե졼Υե졼ֹʻ֡ */

		long avcbe_skip_frame_flag;	/* 0: Υե졼ϥåפʤ1: åפ */

		long avcbe_qsum;	/* ե졼ñ̤Qι(rate_controlǻ) */

		/* ̻ҲνŤդϢ */
		char *avcbe_weightedQ_table1;	/* ޥ֥åȤ̻ҲνŤդꤷơ֥ǿϡޥ֥å */
		char *avcbe_weightedQ_table2;	/* Ʊơ֥2avcbe_weightedQ_mode=AVCBE_WEIGHTEDQ_AUTOΤȤmedian fileter򤫤Ťͤ *//* 050518 */

		/* 2ѥϢ *//* 041026 ưŪ˳ݤ褦ѹ */
		TAVCBE_WORKAREA avcbe_mb_sads_work_buf;	/* ޥ֥åȤSADͳǼ */
		short *avcbe_mb_sads_buf;	/* ޥ֥åȤSADͥԡǿϡ֥ޥ֥å/2ס */
		short *avcbe_mb_sads_buf_lowpath;	/* ޥ֥åȤSADͥԡǿϡ֥ޥ֥å/2ס */
		char *avcbe_mb_quant;	/* ޥ֥åȤQ͡ǿϥޥ֥å) */

		/* ǼưŪ˼Хåå *//* 041027 */
		struct AVCBE_H264_STREAM_INFO *avcbe_backup_H264_stream_info;	/* ¤avcbe_H264_stream_info_t */

		avcbe_sei_dec_ref_pic_marking_repetition_param dec_ref_pic_marking_repet_param;	/* 050426 */

		/* ǽΥȥ饪եå *//* 041101 */
		long avcbe_intra_offset_set_flag;	/* =1:ȥ饪եåͤΥơ֥ͤꤵ줿 */
		long *avcbe_intra_offset_table;	/* ȥ饪եåͤΥơ֥ʱAPIؿavcbe_set_intra_offset()ꤹ */

		/* ǽMBǥХå */
		long avcbe_mb_debug_enable;	/* ǥХåON/OFF *//* 060112 */
		long avcbe_mb_debug_addr;	/* ǥХåνΥɥ쥹 *//* 060112 */

	} avcbe_H264_stream_info_t;



#ifdef __cplusplus
}
#endif
#endif				/* ABCBE_INNER_H */
